Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.swt.layout
Class GridLayout

    java.lang.Object
      org.eclipse.swt.widgets.Layout
          org.eclipse.swt.layout.GridLayout

public final class GridLayout
extends Layout

Instances of this class lay out the control children of a `Composite` in a grid.

`GridLayout` has a number of configuration fields, and the controls it lays out can have an associated layout data object, called `GridData`. The power of `GridLayout` lies in the ability to configure `GridData` for each control in the layout.

The following code creates a shell managed by a `GridLayout` with 3 columns:

     		Display display = new Display();
     		Shell shell = new Shell(display);
     		GridLayout gridLayout = new GridLayout();
     		gridLayout.numColumns = 3;
     		shell.setLayout(gridLayout);

The `numColumns` field is the most important field in a `GridLayout`. Widgets are laid out in columns from left to right, and a new row is created when `numColumns` + 1 controls are added to the `Composite`.

See Also:
  `GridData`

Field Summary
`int` | `horizontalSpacing` horizontalSpacing specifies the number of pixels between the right edge of one cell and the left edge of its neighbouring cell to the right.
`boolean` | `makeColumnsEqualWidth` makeColumnsEqualWidth specifies whether all columns in the layout will be forced to have the same width.
`int` | `marginHeight` marginHeight specifies the number of pixels of vertical margin that will be placed along the top and bottom edges of the layout.
`int` | `marginWidth` marginWidth specifies the number of pixels of horizontal margin that will be placed along the left and right edges of the layout.
`int` | `numColumns` numColumns specifies the number of cell columns in the layout.
`int` | `verticalSpacing` verticalSpacing specifies the number of pixels between the bottom edge of one cell and the top edge of its neighbouring cell underneath.

Constructor Summary
`GridLayout()` Constructs a new instance of this class.
`GridLayout(int numColumns, boolean makeColumnsEqualWidth)` Constructs a new instance of this class given the number of columns, and whether or not the columns should be forced to have the same width.

Method Summary
`protected Point` | `computeSize(Composite composite, int wHint, int hHint, boolean flushCache)` Computes and returns the size of the specified composite's client area according to this layout.
`protected void` | `layout(Composite composite, boolean flushCache)` Lays out the children of the specified composite according to this layout.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### marginWidth

    public int marginWidth

  marginWidth specifies the number of pixels of horizontal margin that will be placed along the left and right edges of the layout. The default value is 5.

### marginHeight

    public int marginHeight

  marginHeight specifies the number of pixels of vertical margin that will be placed along the top and bottom edges of the layout. The default value is 5.

### numColumns

    public int numColumns

  numColumns specifies the number of cell columns in the layout. The default value is 1.

### makeColumnsEqualWidth

    public boolean makeColumnsEqualWidth

  makeColumnsEqualWidth specifies whether all columns in the layout will be forced to have the same width. The default value is false.

### horizontalSpacing

    public int horizontalSpacing

  horizontalSpacing specifies the number of pixels between the right edge of one cell and the left edge of its neighbouring cell to the right. The default value is 5.

### verticalSpacing

    public int verticalSpacing

  verticalSpacing specifies the number of pixels between the bottom edge of one cell and the top edge of its neighbouring cell underneath. The default value is 5.

Constructor Detail

### GridLayout

    public GridLayout()

  Constructs a new instance of this class.

### GridLayout

    public GridLayout(int numColumns,
                      boolean makeColumnsEqualWidth)

  Constructs a new instance of this class given the number of columns, and whether or not the columns should be forced to have the same width.

Parameters:
  `numColumns` - the number of columns in the grid
  `makeColumnsEqualWidth` - whether or not the columns will have equal width
Since:
  2.0

Method Detail

### computeSize

    protected Point computeSize(Composite composite,
                                int wHint,
                                int hHint,
                                boolean flushCache)

  Description copied from class: `Layout`
  Computes and returns the size of the specified composite's client area according to this layout.

  This method computes the minimum size that the client area of the composite must be in order to position all children at their minimum size inside the composite according to the layout algorithm encoded by this layout.

  When a width or height hint is supplied, it is used to constrain the result. For example, if a width hint is provided that is less than the minimum width of the client area, the layout may choose to wrap and increase height, clip, overlap, or otherwise constrain the children.

  Specified by:
    `computeSize` in class `Layout`
  Parameters:
    `composite` - a composite widget using this layout
    `wHint` - width (`SWT.DEFAULT` for minimum)
    `hHint` - height (`SWT.DEFAULT` for minimum)
    `flushCache` - `true` means flush cached layout values
  Returns:
    a point containing the computed size (width, height)
  See Also:
    `Layout.layout(org.eclipse.swt.widgets.Composite, boolean)`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack()`, "computeTrim, getClientArea for controls that implement them"

### layout

    protected void layout(Composite composite,
                          boolean flushCache)

  Description copied from class: `Layout`
  Lays out the children of the specified composite according to this layout.

  This method positions and sizes the children of a composite using the layout algorithm encoded by this layout. Children of the composite are positioned in the client area of the composite. The position of the composite is not altered by this method.

  When the flush cache hint is true, the layout is instructed to flush any cached values associated with the children. Typically, a layout will cache the preferred sizes of the children to avoid the expense of computing these values each time the widget is layed out.

  When layout is triggered explicitly by the programmer the flush cache hint is true. When layout is triggered by a resize, either caused by the programmer or by the user, the hint is false.

  Specified by:
    `layout` in class `Layout`
  Parameters:
    `composite` - a composite widget using this layout
    `flushCache` - `true` means flush cached layout values

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Guidelines for using Eclipse APIs.

Copyright (c) IBM Corp. and others 2000, 2004. All rights reserved.

``